<?php

error_reporting(E_ALL ^ E_NOTICE);
set_error_handler('errorHandler');

//Common tables
define("TBL_USER_ONLINE",          DB_PREFIX."user_online");

//Community Chat tables
define("TBL_CHAT_ROOM",            DB_PREFIX."chat_room");
define("TBL_CHAT_ROOM_CLIENTS",    DB_PREFIX."chat_room_clients");
define("TBL_CHAT_CLIENT",          DB_PREFIX."chat_client");
define("TBL_CHAT_CLIENT_FRIENDS",  DB_PREFIX."chat_client_friends");
define("TBL_CHAT_CLIENT_BLOCKS",   DB_PREFIX."chat_client_blocks");
define("TBL_CHAT_MESSAGE",         DB_PREFIX."chat_message");
define("TBL_CHAT_ADMIN",           DB_PREFIX."chat_admin");
define("TBL_CHAT_BAN",             DB_PREFIX."chat_ban");
define("TBL_CHAT_IP_RANGE_BAN",    DB_PREFIX."chat_ip_range_ban");
define("TBL_CHAT_SETTINGS",        DB_PREFIX."chat_settings");
define("TBL_CHAT_FILTERS",         DB_PREFIX."chat_filters");

//Communicator tables
define("TBL_COMMUNICATOR_MESSAGE", DB_PREFIX."communicator_message");

//Site Messenger tables
define("TBL_MESSENGER_CLIENT",     DB_PREFIX."messenger_client");
define("TBL_MESSENGER_MESSAGE",    DB_PREFIX."messenger_message");

//Profile Recorder tables
define("TBL_RECORDER_RECORD",      DB_PREFIX."recorder");

//Site Mail tables
define("TBL_SITE_MAIL",            DB_PREFIX."sitemail");
define("TBL_SITE_MAIL_CONTENT",    DB_PREFIX."sitemail_content");

//Plugins tables
define("TBL_PLUGIN_REPORT_A_USER", DB_PREFIX."plugin_report_a_user");
define("TBL_PLUGIN_HISTORY",       DB_PREFIX."plugin_history");
define("TBL_PLUGIN_HISTORY_BAN",   DB_PREFIX."plugin_history_ban");
define("TBL_PLUGIN_HISTORY_KICK",  DB_PREFIX."plugin_history_kick");
define("TBL_VIDEOCHAT_USERS",      DB_PREFIX."videochat_users");
define("TBL_PLUGIN_PREMODERATION", DB_PREFIX."plugin_premoderation");
define("TBL_PLUGIN_PREMODERATION_MESSAGE", DB_PREFIX."plugin_premoderation_message");
define("TBL_PLUGIN_VOTE_TO_KICK",          DB_PREFIX."plugin_vote_to_kick");
define("TBL_PLUGIN_COMMUNICATOR_HISTORY",  DB_PREFIX."plugin_communicator_history");

function trace($message, $isWriteLog = true)
{
    $content = print_r($message, true);
    if($isWriteLog)
    {
        $handle = @fopen(LOG_DIR.'log.txt', 'a');
        @fwrite($handle, date("Y-m-d H:i:s")."\r\n".$content."\r\n\r\n");
        @fclose($handle);
    }
    else echo "<pre>".$content."</pre><br>";
}

function errorHandler($code, $msg, $file, $line)
{
    switch ($code)
    {
        case 2048: break; //ignore PHP5 errors
        case E_USER_ERROR:
            trace("*FATAL* $msg ($file:$line)");
            exit(1);
            break;
        case E_USER_WARNING:
            trace("*ERROR* $msg ($file:$line)");
            break;
        case E_USER_NOTICE:
            trace("*WARNING* $msg ($file:$line)");
            break;
        default: trace("$msg ($file:$line)");
    }
}

function showUpgradePlayerMessage($version = 8)
{
    $link = "http://www.adobe.com/go/getflashplayer";
    $message = "<p>You need to upgrade your Flash Player.</p>\n";
    $message .= "<p>Version ".$version." or higher is required.</p>\n";
    $message .= "download from <a href=\"".$link."\">".$link."</a>\n";
    return $message;
}

function renderApplication($application, $params, $width="100%", $height="100%", $bgColor = "#ffffff")
{
    $anticash = "?anticash=".rand(100, 5000);
    $loader = FLASHCOMS_HTTP_ROOT."flashcoms.swf".$anticash;
    $code = $application."/".$application.".swf".$anticash;
    $skin = $application."/skins/main.swf".$anticash;
    ?>
    <div id="<?php echo $application; ?>_swf" style="width:<?php echo $width; ?>; height:<?php echo $height; ?>">
    <p><strong>Flashcoms</strong></p>
    <?php echo showUpgradePlayerMessage(8); ?>
    </div>
    <script type="text/javascript">
        // <![CDATA[
        var so = new SWFObject(
            "<?php echo $loader; ?>",
            "<?php echo $application; ?>",
            "100%", "100%", "8",
            "<?php echo $bgColor; ?>");
        so.addVariable("rootPath", "<?php echo FLASHCOMS_HTTP_ROOT; ?>");
        so.addVariable("code", "<?php echo $code; ?>");
        so.addVariable("skin", "<?php echo $skin; ?>");
        <?php
        foreach($params as $param => $value)
        {
            echo 'so.addVariable("'.$param.'", "'.$value.'"); ';
            echo "\n        ";
        }
        ?>
        so.write("<?php echo $application; ?>_swf");
        // ]]>
    </script>
    <?php
}

function renderUpdater($uid)
{
    $params = array("uid" => $uid, "userName" => $uid);
    renderApplication("updater", $params, 350, 200);
}

function renderLoginForm($action)
{
    ?>
	<form action="./test.php" method="get" />
	<table border="0" align="center" cellpadding="0" cellspacing="0">
		<tr>
			<td>
				<input type="hidden" name="action" value="<?php echo $action; ?>" />
				<font style="font-size:15px;color:#336699;">Login as:</font>
			</td>
			<td width="5px" align="center" style="background-image:url(common/images/submit_l.gif);background-repeat:no-repeat; background-position:center"></td>
			<td align="center" style="vertical-align: middle"><input type="text" name="userName" class="text" style="vertical-align: middle" /></td>
			<td width="5px" align="center" style="background-image:url(common/images/submit_r.gif);background-repeat:no-repeat; background-position:center"></td>
			<td width="5px" style="background-image:url(common/images/submit_l.gif);background-repeat:no-repeat;background-position:center"></td>
			<td align="center"><input type="submit" value="Enter" /></td>
			<td width="5px" style="background-image:url(common/images/submit_r.gif);background-repeat:no-repeat;; background-position:center"></td>
		</tr>
	</table>
	</form>
    <?php
}

function checkInputParameters($strParams)
{
    $arrParams = explode(",", $strParams);
    $len = count($arrParams);
    for($i = 0; $i < $len; $i++)
    {
        $param = $arrParams[$i];
        if(!isset($_GET[$param]) && !isset($_POST[$param]))
        {
            die("invalid parameters - ".$arrParams[$i]." is undefined");
        }
    }
}

function getInputParam($param, $defaultValue = "")
{
    $value = $defaultValue;

    if( isset($_POST[$param]) ) $value = $_POST[$param];
    else if( isset($_GET[$param]) ) $value = $_GET[$param];

    if(get_magic_quotes_gpc()) $value = stripslashes($value);

    return $value;
}

?>
